

--Base Callbacks
function apiLoad()
	print("Loading... Personal API")
	Title = wd.getTitle()
	garbage_timer = 0
	print("Done")
	print("Loading... Map.lua")
	require "map"
	print("Done")
	print("Loading... Player.lua")
	require "player"
	print("Done")
	print("Loading... Pathfind.lua")
	require "pathfind"
	print("Done")
end

function apiUpdate(dt)
	mouseX, mouseY = ms.getPosition()
	wd.setTitle(Title.." FPS: "..tm.getFPS())
	garbage_timer = garbage_timer + dt
	if garbage_timer >= 250 then
		collectgarbage()
		print("Garbage Collection Successful")
		garbage_timer = 0
	end
end

function apiDraw()
end


--Love 2D simplified Modules/Variables
gr = love.graphics
fs = love.filesystem
wd =love.window
tm = love.timer
ms = love.mouse
width, height = love.graphics.getWidth(),love.graphics.getHeight()

--Mathematical Alogrithms--
function dist(x1, y1, x2, y2)
	return math.sqrt(((x2-x1)^2)+((y2-y1)^2))
end

function distV(v1, v2)
	return math.sqrt(((v2.x-v1.x)^2)+((v2.y-v1.y)^2))
end

function slope(x1, y1, x2, y2)
	return (y2 - y1)/(x2 - x1)
end

function clamp(val, low, up)
	if low > up then low, up = up, low end
	return math.max(low, math.min(val, up))
end

function math.round(val)
	local n
	if val%1 >= .5 then
		n = val - (val%1) + 1
	else
		n = val - (val%1)
	end
	return n
end

function round(val, deci)
	local mult = math.pow(10, deci)
	return math.round(val * mult) / mult
end

function roundNearest(val, nearest)
	return math.round(val / nearest) * nearest
end

--Logical Callbacks
function boxCollision(x1, y1, w1, h1, x2, y2, w2, h2)
	return y1 < y2 + h2 and y2 < y1 + h1 and x1 < x2 + w2 and x2 < x1 + w1
end

--Base Variables
smallF = gr.newFont(12)
mediumF = gr.newFont(16)
largeF = gr.newFont(18)

--Move to functions
function moveEntity(entity, goal, dt)
		local theta = math.atan2((goal.y+16) - (entity.y+(entity.h/2)), (goal.x + 16) - (entity.x+(entity.w/2)))
		entity.dx = entity.speed * math.cos(theta)
		entity.dy = entity.speed * math.sin(theta)
		entity.x = entity.x + (entity.dx*dt)
		entity.y = entity.y + (entity.dy*dt)
end